#include "text.h"
#include <iostream>

using namespace std;

void show_histogram_text(const vector<size_t>& bins) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    size_t max_count = 0;
    for (size_t count : bins) {
        if (count > max_count) {
            max_count = count;
        }
    }

    for (size_t bin : bins) {
        if (bin < 100) cout << " ";
        if (bin < 10) cout << " ";
        cout << bin << "|";

        size_t height = bin;
        if (max_count > MAX_ASTERISK) {
            if (max_count != bin)
                height = MAX_ASTERISK * (static_cast<float>(bin) / max_count);
            else
                height = MAX_ASTERISK;
        }

        for (size_t i = 0; i < height; i++) cout << "*";
        cout << "\n";
    }
}
