#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("all numbers are same") {
    double min = 0;
    double max = 0;
    find_minmax({5, 5, 5, 5}, min, max);
    CHECK(min == 5);
    CHECK(max == 5);
}

TEST_CASE("with negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-3, -7, -1}, min, max);
    CHECK(min == -7);
    CHECK(max == -1);
}

TEST_CASE("single number") {
    double min = 0;
    double max = 0;
    find_minmax({42}, min, max);
    CHECK(min == 42);
    CHECK(max == 42);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    find_minmax({}, min, max);
    CHECK(min == 0);
    CHECK(max == 0);
}
